# -*-coding:utf-8 -*- #

import pymysql

from BPMInterfaceAutoTest.common import log
from BPMInterfaceAutoTest.common.read_excel import ReadExcel
from BPMInterfaceAutoTest.common.read_ini import ReadIni


class DB:
    def __init__(self):
        read_ini = ReadIni()

        try:
            self.conn = pymysql.connect(
                host=read_ini.get_sql_conn_msg("sql_host"),
                port=int(read_ini.get_sql_conn_msg("port")),
                user=read_ini.get_sql_conn_msg("user"),
                password=read_ini.get_sql_conn_msg("password"),
                database=read_ini.get_sql_conn_msg("database"),
                charset="utf8"
            )
            self.cursor = self.conn.cursor()
        except:
            log.error("链接数据库信息错误，请检查链接数据库代码或配置文件")
            raise pymysql.Error("链接数据库信息错误，请检查链接数据库代码或配置文件")

    def select(self, sql_sentence):
        try:
            self.cursor.execute(sql_sentence)
        except:
            log.error("数据库查询失败，请到sql_sentence.json文件中检查数据库查询sql语句")
            raise NameError("数据库查询失败，请到sql_sentence.json文件中检查数据库查询sql语句")
        else:
            select_result = self.cursor.fetchall()
            return select_result[0][0]

    def delete(self, sql_sentence):
        try:
            self.cursor.execute(sql_sentence)
            self.conn.commit()
        except:
            log.error("数据库删除失败，请到sql_sentence.json文件中检查数据库删除sql语句")
            raise NameError("数据库删除失败，请到sql_sentence.json文件中检查数据库删除sql语句")

    def close(self):
        self.cursor.close()
        self.conn.close()


if __name__ == '__main__':
    db = DB()

    # sql1 = "select ID_ from uc_demension where CODE_='test57_bpm_api_test_dem_ls';"
    # sql2 = "delete from uc_demension where CODE_='xxxxxxx'"

    case_data = ReadExcel().get_data()[-2][-3]["select"]
    print(db.select(case_data))
    # db.delete(sql2)
