# -*-coding:utf-8 -*- #
import allure
import pytest

from BPMInterfaceAutoTest.common import log
from BPMInterfaceAutoTest.common.read_excel import ReadExcel


class TestBPM:
    @allure.epic("BPM项目")
    @pytest.mark.parametrize(
        "module_name, api_name, title, level, method, url, mime, case_data, expect_data, sql_sentence, sql_sentence_type, update_key",
        ReadExcel().get_data())
    def test_bpm(self, request_fix, db_fix, module_name, api_name, title, level, method, url, mime, case_data,
                 expect_data, sql_sentence, sql_sentence_type, update_key):
        allure.dynamic.feature(module_name)
        allure.dynamic.story(api_name)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)

        if sql_sentence_type == "delete":
            db_fix.delete(sql_sentence["delete"])
        elif sql_sentence_type == "select":
            select_result = db_fix.select(sql_sentence.get("select"))
            case_data[update_key] = select_result
        elif sql_sentence_type == "select|delete" or sql_sentence_type == "delete|select":
            db_fix.delete(sql_sentence["delete"])
            select_result = db_fix.select(sql_sentence.get("select"))
            case_data[update_key] = select_result

        res = request_fix.request_all(method=method, url=url, case_data=case_data, mime=mime)
        print(res.text)

        for key in expect_data:
            try:
                assert expect_data[key] == res.json()[key]
            except AssertionError:
                log.error("断言失败，预期结果为：" + str(expect_data) + "，实际结果为：" + str(res.json()))
                raise ValueError("断言失败")


if __name__ == '__main__':
    pytest.main()
